/* $Header: /home/dl2/nygren/cvs/pan/src/applib/appcodeobj.h,v 1.2 1997/10/06 20:18:40 nygren Exp $
 *
 * FILE:    appcodeobj.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Routines to make it easier for a PAN application to load code
 * objects and to insert them into nodes.
 *
 */

#ifndef APPLIB_APPCODEOBJ_H_INC
#define APPLIB_APPCODEOBJ_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <common/nodeaddr.h>
#include <common/pancodeobj.h>

#include <applib/nodelink.h>

#define panAppCodeobj_FILE_EXTENSION        ".po"
#define panAppCodeobj_FILE_EXTENSION_LENGTH 3

/* Just a memory-mapped swseg of the code object file... */
typedef panSwseg panAppCodeobj;

extern panAppCodeobj *
panAppCodeobj_load(char *filename);

extern int
panAppCodeobj_insertIntoNode(panNodeLink *nl, panAppCodeobj *aco, int pin);

extern int
panAppCodeobj_getCodeobjName(panCodeobjName *coname, panAppCodeobj *aco);


#endif /* APPLIB_APPCODEOBJ_H_INC */
