/* $Header: /home/dl2/nygren/cvs/pan/src/applib/nodelink.h,v 1.1 1997/09/09 19:26:55 nygren Exp $
 *
 * FILE:    nodelink.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Routines that an application can use to connect to a PAN node, 
 * insert capsules into it, and get data back from it.
 *
 */

#ifndef APPLIB_NODELINK_H_INC
#define APPLIB_NODELINK_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <common/nodeaddr.h>

/* The specific implementation of this structure is 
 * defined in the architecture-dependent code */
typedef struct _panNodeLink panNodeLink;

extern panNodeLink *
panNodeLink_create(char *nodename);

extern int
panNodeLink_send(panNodeLink *nl, panStream *capstart, int caplength);

extern panSwseg *
panNodeLink_retr(panNodeLink *nl, int block);

extern int
panNodeLink_read(panStream *ps, panNodeLink *nl, int nbytes);

extern int
panNodeLink_isConnected(panNodeLink *nl);

extern int
panNodeLink_getSockFD(panNodeLink *nl);

extern int
panNodeLink_getLocalAddr(panNodeAddr *na, panNodeLink *nl);

extern void
panNodeLink_disconnect(panNodeLink *nl);

extern void
panNodeLink_destroy(panNodeLink *nl);


#endif /* APPLIB_NODELINK_H_INC */
