#!/usr/bin/perl

@packet_sizes = ( 128, 256, 512, 1024, 1500, 1504, 2048, 4096, 8192);

# map from packet size to count (get around stooopid bugs...)
%size_to_count = ( 
		  128  => 5000, 
		  256  => 2000,
		  512  => 1000,
		  1024 => 800,
		  1500 => 500,
		  1504 => 500,
		  2048 => 250,
		  4096 => 150,
		  8192 => 80
		  );

# user active 
#%size_to_count = ( 
#		  128  => 3000, 
#		  256  => 1500,
#		  512  => 800,
#		  1024 => 400,
#		  1500 => 150,
#		  1504 => 100,
#		  2048 => 80,
#		  4096 => 30,
#		  8192 => 15
#		  );

############################## headersize, localport, destination
%configmap = ( 
	      "kernelactive"  => [ 20, "",     "10.1.0.8" ],
	      "kernelpassive" => [ 20, "",     "10.1.0.8" ],
	      "kernelnone"    => [ 20, "",     "10.0.0.8" ],
	      "useractive"    => [ 28, "3250", "10.1.0.8:3250" ],
	      "userpassive"   => [ 28, "3250", "10.1.0.8:3250" ],
	      "usernone"      => [ 28, "3250", "10.0.0.8:3250" ],
	      "usercforw"     => [ 28, "3250", "10.1.0.8:3250" ],
	      "testactive"    => [ 28, "3256", "mindwipe:9764" ]
	      );

sub do_flood
{
    my ($count, $size, $dest, $local) = @_;
    my ($localopt, $totalbytes, $capcount, $duration, $kbps, $pvers) 
	= ("", 0, 0, 0, 0, ".kernel");

    if ($local) {
	$localopt = "-L $local";
	$pvers = ".user";
    }

    open PINGOUT, "./floodapp$pvers -i -c $count -s $size $localopt $dest |" or die "couldn't start up ping";
    
    while (<PINGOUT>) 
    {
	if (/.*duration=([0-9]+) usecs for ([0-9]+) capsules and ([0-9]+) bytes .*= ([0-9]+\.[0-9]+) Kbps.*/) {
	    $duration = $1;  $capcount=$2; $totalbytes = $3; $kbps = $4; 
	}
    }

    close PINGOUT;
#    print "results: $totalbytes bytes  $capcount caps  $duration usecs  $kbps kbps ($localopt)\n";
#    print "         capsize ".($totalbytes/$capcount)."\n";
    return ($totalbytes, $capcount, $duration, $kbps);
}


#do_flood(600, 1004, "10.1.0.8:3250", 3250);
#do_flood(600, 1004, "10.1.0.8");
#exit -1;

$nodetype = $ARGV[0];
$nettype  = $ARGV[1];
$startpaksize = $ARGV[2];
$testtype = ($nodetype.$nettype);
(("" eq $nodetype) || ("" eq $nettype)) and die "invalid arguments\n";
if ($startpaksize eq "") { 
    $startpaksize = 0; 
    open RESULTS, ">flood.results.$testtype.csv" or die "couldn't open output file";
    print "outputting results to flood.results.$testtype.csv\n";
} else {
    open RESULTS, ">>flood.results.$testtype.csv" or die "couldn't open output file";
    print "appending results to flood.results.$testtype.csv\n";
}


$configmap{$testtype} or die "unknown test type <$testtype>\n";
print "test type = $testtype ($nodetype+$nettype)\n";

($headersize, $localport, $destination) = @{$configmap{$testtype}};

$header = sprintf "%8s, %8s, %8s, %8s, %8s, %8s, %8s, %8s\n",
    "nodetype", "nettype", "runcnt", "paksiz", "capsiz",
    "totbytes", "duration", "kbps";
print RESULTS $header;
print $header;

# Prime the link first...
#foreach $currun (1..3) {
#    ($totalbytes, $ret_count, $rttmin, $rttavg, $rttmax) = 
#	do_flood(100, 0, $destination, $localport);
#    $results = sprintf "%8s, %8s, %8s, %8s, %8s, %8s, %8s, %8s\n",
#    $nodetype, $nettype, $ret_count, $retcapsize+headersize, 
#    $retcapsize, $rttmin, $rttavg, $rttmax;
#    print RESULTS $results;
#    print $results;
#    sleep(2);
#}

sub do_multi_flood
{
    my ($count, $size, $dest, $local) = @_;

    my ($runcount, $totalbytesaccum, $capcountaccum,
	$durationaccum, $kbpsaccum)
	= (0, 0, 0, 0, 0);
    foreach $currun (1..10)
    {
	($totalbytes, $capcount, $duration, $kbps) = 
	    do_flood($count, $size, $dest, $local);
	$runcount++;
	$totalbytesaccum += $totalbytes;
	$capcountaccum   += $capcount;
	$durationaccum   += $duration;
	$kbpsaccum       += $kbps;
	printf "%8s, %8s, %8s, %8s, %8s, %8s, %8s, %8s ...\n",
	$nodetype, $nettype, $capcount, $totalbytes/$capcount, 
	"xxx", $totalbytes, $duration, $kbps;
	sleep(1);
    }
    return ($totalbytesaccum, $capcountaccum, $durationaccum, 
	    $kbpsaccum/$runcount);
}

foreach $curpaksize (@packet_sizes)
{
    if ($curpaksize < $startpaksize) {
	printf "skipping $curpaksize ...\n";
	next;
    }
    foreach $currun (1..3) 
    {
	$runcount = $size_to_count{$curpaksize};
	$runcount or die "invalid size_to_count mapping\n";
	($totalbytes, $ret_capcount, $duration, $kbps) = 
	    do_multi_flood($runcount, $curpaksize-$headersize, 
		    $destination, $localport);
	$results = sprintf "%8s, %8s, %8s, %8s, %8s, %8s, %8s, %8s\n",
	$nodetype, $nettype, $ret_capcount, $totalbytes/$ret_capcount, 
	$curpaksize-$headersize, $totalbytes, $duration, $kbps;
	print $results;
	print RESULTS $results;
	close RESULTS;
	open RESULTS, ">>flood.results.$testtype.csv" or die "couldn't open output file";
	sleep(1);	
    }
}

close RESULTS;
