/* $Header: /home/dl2/nygren/cvs/pan/src/apps/testtraverse/testapp.c,v 1.3 1997/12/10 06:58:18 nygren Exp $
 *
 * FILE:    testapp.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 *
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h>

#include <applib/panapplib.h>

void
main(int argc, char **argv)
{
  panNodeLink    *pnl;
  panAppCodeobj  *testtraverse_co;
  panCodeobjName  testtraverse_coname;
  panSwseg       *capsws;
  panStream       _ps, *ps=&_ps;
  panNodeAddr     localaddr, destaddr;

  if (argc != 3) 
    { printf("Usage: %s localport destaddr\n", argv[0]);  sleep(3); exit(-1);  }
  if (!argv[1])
    { printf("No node name given\n");  sleep(3); exit(-1);  }
  if (!argv[2])
    { printf("No destination address given\n");  sleep(3); exit(-1);  }

  printf("Connecting to the node <%s>...\n", argv[1]);
  pnl = panNodeLink_create(argv[1]);
  if (!pnl)
    { printf("Couldn't create nodelink!\n"); sleep(3); exit(-1); }
  printf("Yay!  Connected!\n");

  if (!panNodeAddr_parse(&destaddr, argv[2]))
    { printf("Couldn't parse dest address!\n"); sleep(3); exit(-1); }

  if (!(testtraverse_co = panAppCodeobj_load("testtraverse")))
    { printf("Couldn't load codeobject!\n"); sleep(3); exit(-1); }
  if (!panAppCodeobj_getCodeobjName(&testtraverse_coname, testtraverse_co))
    { printf("Couldn't get coname!\n"); sleep(3); exit(-1); }

  if (!panAppCodeobj_insertIntoNode(pnl, testtraverse_co, 1))
    { printf("Couldn't insert codeobject!\n"); sleep(3); exit(-1); }

#define TESTCAPSIZE panCodeobjName_SIZE + 2*panNodeAddr_SIZE + 256

  capsws = panSwseg_create_byMalloc(TESTCAPSIZE);

  panNodeLink_getLocalAddr(&localaddr, pnl);
  
  panStream_init(ps, capsws, 0);
  panCodeobjName_write(ps, &testtraverse_coname);
  panNodeAddr_write(ps, &localaddr);
  panNodeAddr_write(ps, &destaddr);
  panStream_write_net_uint32(ps, 0x12345678);

  panStream_init(ps, capsws, 0);
  panNodeLink_send(pnl, ps, TESTCAPSIZE);

  sleep(10);
  panNodeLink_disconnect(pnl);
  panNodeLink_destroy(pnl);
  
}
