/* $Header: /home/dl2/nygren/cvs/pan/src/codeobj/portmap/portmap.h,v 1.1 1997/12/10 06:58:20 nygren Exp $
 *
 * FILE:    portmap.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Provides routines for mapping port numbers to applications.
 *
 */


#ifndef INC_CODEOBJ_PORTMAP_H
#define INC_CODEOBJ_PORTMAP_H

#include <common/pan-copyright.h>

/* Operations and return values */
#define pcoPortmap_OP_BIND         1 /* binds to a port */
#define pcoPortmap_OP_DELETE       2 /* deletes a port mapping */
#define pcoPortmap_RVAL_SUCCESS    0 /* operation succeeded */
#define pcoPortmap_RVAL_EINUSE    -1 /* port already in use */
#define pcoPortmap_RVAL_EFULL     -2 /* insufficient resources */
#define pcoPortmap_RVAL_EPERM     -3 /* permission denied */
#define pcoPortmap_RVAL_ENOTFOUND -4 /* port doesn't exist */
#define pcoPortmap_RVAL_ENOALINK  -5 /* no applink to bind to */
#define pcoPortmap_RVAL_EINVAL    -6 /* invalid argument */
#define pcoPortmap_RVAL_ELINKFAIL -7 /* couldn't load a codeobj or send cap */


#ifdef PAN_CODEOBJ /* We're building a codeobj */

#include <pni/pniswseg.h>

extern int 
pcoPortmap_bindPortnumToApplink(int *portnum);

extern pniAppLink *
pcoPortmap_mapPortnumToApplink(int portnum);

extern int
pcoPortmap_deletePortnumMapping(int portnum);

#else  /* We're building an application */

extern int
palPortmap_bind(panNodeLink *nl, int *portnum, int insertco);

extern int
palPortmap_release(panNodeLink *nl, int portnum);

#endif /* if/else PAN_CODEOBJ */




#endif /* INC_CODEOBJ_PORTMAP_H */
