/* $Header: /home/dl2/nygren/cvs/pan/src/common/arch/linux2/timestamp.c,v 1.1 1998/01/18 00:11:59 nygren Exp $
 *
 * FILE:    timestamp.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Routines for getting timing information from a node.  Node that times
 * are particular to individual nodes and may not be synchronized
 * between nodes.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swsstream.h>
#include <common/timestamp.h>

#ifdef KERNEL
#include <linux/time.h>
#else
#include <sys/time.h>
#include <unistd.h>
#endif

int
panTimestamp_getCurrent(panTimestamp *ts)
{
#ifdef KERNEL
  do_gettimeofday((struct timeval *)ts);
  return 0;
#else
  return gettimeofday((struct timeval *)ts, NULL);
#endif
}

int
panTimestamp_getResolution(panTimestamp *res)
{
  res->sec=0;
#ifdef KERNEL
  res->usec=2;
#else
  res->usec=panTimestamp_USEC_RESOLUTION; 
#endif

  return 0;
}

