/* $Header: /home/dl2/nygren/cvs/pan/src/common/arch/unixuser/timestamp.c,v 1.1 1998/01/18 00:12:00 nygren Exp $
 *
 * FILE:    timestamp.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Routines for getting timing information from a node.  Node that times
 * are particular to individual nodes and may not be synchronized
 * between nodes.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swsstream.h>
#include <common/timestamp.h>

#include <sys/time.h>
#include <unistd.h>

int
panTimestamp_getCurrent(panTimestamp *ts)
{
  return gettimeofday((struct timeval*)ts, NULL);
}

int
panTimestamp_getResolution(panTimestamp *res)
{
  res->sec=0;
  res->usec=panTimestamp_USEC_RESOLUTION; 
  return 0;
}

