/* $Header: /home/dl2/nygren/cvs/pan/src/common/conventions.h,v 1.2 1997/12/18 02:33:21 nygren Exp $
 *
 * FILE:    conventions.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Standard conventions shared throughout PAN.  
 * This includes things like path names for unix domain sockets,
 * protocol numbers, etc.
 *
 */

#ifndef COMMON_CONVENTIONS_H_INC
#define COMMON_CONVENTIONS_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/nodeaddr.h>


/******************* FOR USER SPACE NODES ********************/

/* Directory where communication sockets are created 
 * for user-space nodes. */
#define panNodeAppIF_SOCKDIR_NAME "/tmp/.PAN-unix"
#define panNodeAppIF_SOCKDIR_MODE 0777





/******************* FOR KERNEL SPACE NODES ********************/

/* Address family for communicating to kernel-space nodes.
 * WARNING:  This is unregistered and higher than AF_MAX 
 * for either Linux or OpenBSD so there may potentially be some 
 * conflicts. */
#define AF_PAN      34		/* Practical Active Network node sockets */
#define PF_PAN      AF_PAN


#define IPPROTO_PAN      34	/* TODO: find an unregistered number.
				 * The IP Protocol Type for PAN. 
				 * Maybe for active nets in general? */


/* For communicationg addresses between kernel and user space */
struct sockaddr_pan {
  unsigned short span_family;	/* AF_PAN */
  panNodeAddr    span_addr;	/* the node address */
};




#endif /* COMMON_CONVENTIONS_H_INC */
