/* $Id: bintoc.c,v 1.2 1997/12/04 00:47:49 nygren Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

extern char *optarg;
extern int optind;

/* long nskip = 0x20; */
long nskip = 0;
int lenmask = 0xfff;

static void
usage (void)
{
  fprintf (stderr, "usage: bintoc [-S] [-s skipbytes] [-l log2_len_allign] "
	   "file.bin array_name\n");
  exit (1);
}

int
main (int argc, char **argv)
{
  unsigned char c;
  int asmout = 0;
  int len = 0;
  int opt;
  FILE *fp;

  setvbuf(stdout, NULL, _IOFBF,0); 


  while ((opt = getopt (argc, argv, "Ss:l:")) != -1) {
    switch (opt) {
    case 'S':
      asmout = 1;
      break;
    case 'l':
      lenmask = atoi (optarg);
      if (lenmask < 0 || lenmask > 16)
	usage ();
      lenmask = (1 << lenmask) - 1;
      break;
    case 's':
      nskip = atoi (optarg);
      break;
    case '?':
    default:
      usage ();
      break;
    }
  }
  argc -= optind;
  argv += optind;

  if (argc != 2)
      usage ();

  if (! (fp = fopen (argv[0], "r"))
      || fseek (fp, nskip, 0)) {
    perror (argv[0]);
    exit (1);
  }

  if (asmout) {
    printf ("\t.text\n\n\t.global _%s\n_%s:", argv[1], argv[1]);
  }
  else {
    printf ("unsigned char %s[] = {\n", argv[1]);
  }

  while (fread (&c, 1, 1, fp) == 1) {
    if (!(len++ & 0x7)) {
      if (asmout)
	printf ("\n\t.byte");
      else if (len > 1)
	printf (",\n");
    }
    else
      printf (",");
    printf (" 0x%02x", c);
  }
  while (len & lenmask) {
    if (!(len++ & 0x7)) {
      if (asmout)
	printf ("\n\t.byte");
      else if (len > 1)
	printf (",\n");
    }
    else
      printf (",");
    printf (" 0x00");
  }
  if (asmout) {
    printf ("\n\n\t.globl _%s_size\n_%s_size:\n"
	    "\t.long (_%s_size - _%s)\t\t# 0x%x\n",
	    argv[1], argv[1], argv[1], argv[1], len);
  }
  else {
    printf ("\n};\n");
    printf ("const unsigned int %s_size = sizeof (%s);  /* 0x%x */\n",
	    argv[1], argv[1], len);
  }
  return (0);
}
