#!/usr/bin/perl
# 
# Quick script that reads in a kernel symbol table and 
# then takes addresses and prints out where those addresses are.
#
# Passed the symbol table file as an argument
#


sub findsym {
    my ($addr, $stab) = @_;
    my $lastaddr = "00000000";

    @saddrsaddr = sort(keys %$stab);
    foreach $curaddr (@saddrsaddr) {
	if ($curaddr ge $addr) {
	    printf "%s is in %s-(%s-1) = %s\n",
	    $addr, $lastaddr, $curaddr, $stab->{$lastaddr}, $curaddr;
	    return;
	}
	$lastaddr = $curaddr;
    }
    printf "%s is in ATEND %s (%s)\n", $addr, $lastaddr, $stab->{$lastaddr};
}

%symtab;

foreach $symline (<>) {
    if ($symline =~ /^([0-9A-Fa-f]+) (.*)$/) {
	$addr = sprintf "%08s", $1;
	$symtab{$addr} = $2;
    }
}

foreach $lookup (<STDIN>) {
    $lookup =~ s/^[^0-9A-Za-z]*([0-9A-Za-z]+)[^0-9A-Za-z]*$/$1/;
    findsym $lookup, \%symtab;
}
