# $Header: /home/dl2/nygren/cvs/pan/src/etc/pansergen/psgLocation.pm,v 1.1 1997/11/14 07:24:05 nygren Exp $
#
###########################################################################
#
# Copyright (C) 1997 by the
#   Laboratory for Computer Science, Massachusetts Institute of Technology
#   545 Technology Square
#   Cambridge, MA 02139
#
# Permission to use, copy, modify, distribute, and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the authors and
# copyright holders not be used in advertising or publicity pertaining
# to distribution of the software without specific, written prior
# permission.  The authors and copyright holders make no
# representations about the suitability of this software for any
# purpose.  It is provided "as is" without express or implied
# warranty.
#
# THE AUTHORS AND COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
###########################################################################
#
# FILE:    psgLocation.pm
# AUTHORS: Erik Nygren (nygren@mit.edu)
#
# Keeps track of a location in a file (ie, a line number and a 
# file name).
#

require 5.002;

BEGIN {		
  push(@INC,  ("../parselex"));
}

use Parse::CLex;

package psgLocation;

sub new {
    my ($type, $lineno, $filename) = @_;
    my $self = {};
    $self->{lineno} = $lineno;
    $self->{filename} = $filename;
    return bless $self, $type;
}

sub getLineNumber {
    my ($self) = @_;
    return $self->{lineno};
}

sub getFilename {
    my ($self) = @_;
    return $self->{filename};
}

sub stringify {
    my ($self, $msg) = @_;
    return $self->getFilename.":".$self->getLineNumber;
}

sub printWarn {
    my ($self, $msg) = @_;
    print $self->getFilename.":".$self->getLineNumber.":  warning: ".$msg."\n";
}

sub printError {
    my ($self, $msg) = @_;
    print $self->getFilename.":".$self->getLineNumber.":  error: ".$msg."\n";
}

