# $Header: /home/dl2/nygren/cvs/pan/src/etc/pansergen/psgTaggedVal.pm,v 1.1 1997/11/14 07:24:08 nygren Exp $
#
###########################################################################
#
# Copyright (C) 1997 by the
#   Laboratory for Computer Science, Massachusetts Institute of Technology
#   545 Technology Square
#   Cambridge, MA 02139
#
# Permission to use, copy, modify, distribute, and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of the authors and
# copyright holders not be used in advertising or publicity pertaining
# to distribution of the software without specific, written prior
# permission.  The authors and copyright holders make no
# representations about the suitability of this software for any
# purpose.  It is provided "as is" without express or implied
# warranty.
#
# THE AUTHORS AND COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
###########################################################################
#
# FILE:    psgTaggedVal.pm
# AUTHORS: Erik Nygren (nygren@mit.edu)
#
# A psgObject derivative for generalizing (tag value) pairs.
# The tag is a string and the value may be any scalar.

require 5.002;

BEGIN {		
  push(@INC,  ("../parselex"));
}

use Parse::CLex;
use psgObject;

package psgTaggedVal;
@ISA = qw( psgObject );


# Passed a tag, a value, and an object to inherit its location from
sub new {
    my ($type, $tag, $val, $locsrc) = @_;
    return $val if $val->isError;
    my $self = psgObject->new($locsrc->getLocation());
    $self->{tv_tag} = $tag;
    $self->{tv_val} = $val;    
    return bless $self, $type;
}

sub getTag {
    my ($self) = @_;
    return $self->{tv_tag};
}

sub getVal {
    my ($self) = @_;
    return $self->{tv_val};
}

sub getDebug {
    my ($self) = @_;
    return "(taggedval:".$self->getLineNumber." ".$self->getTag." ".$self->getVal->getDebug.")";
} 

