/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/linux2/globalsyms_platdep.c,v 1.5 1998/01/20 23:45:56 nygren Exp $
 *
 * FILE:    globalsyms_platdep.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * List of all globally exported symbols with which to initialize the 
 * symbol table.
 *
 * These are symbols that depend on platform-dependent sections of code.
 * (Such as things that may be implemented differently for different
 * types of network interfaces.)
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <node/nodecodeobj.h>
#include <node/symtab.h>

#include <pni/pninetwork.h>
#include <pni/pniapplink.h>
#include "knode_stubs.h"
#include "knode_util.h"
#include "app_if.h"
#include "net_if.h"
#include "kpand.h"


panSymbol panSymTab_GlobalSymbols_PlatformDependent[] = {

  /******* From pni/pnimisc.h *******/
#if PAN_DEBUG == 0
  panSymbol_MAPFUNC (pniLog_debug, printk_noop)
#else
  panSymbol_MAPFUNC (pniLog_debug, printk)
#endif
  panSymbol_MAPFUNC (pniLog_msg,   printk)
  panSymbol_MAPFUNC (pniLog_error, printk)
  panSymbol_MAPFUNC (pniLog_warn,  printk)

  /***************** From pni/network.h *****************/
  panSymbol_MAPFUNC (pniNetwork_sendCapsule,     panNodeNetIF_sendCapsule)
  
  /***************** From pni/applink.h *****************/
  panSymbol_MAPFUNC (pniAppLink_deliverData,     panNodeAppLink_deliverData)
  panSymbol_MAPFUNC (pniAppLink_isConnected,     panNodeAppLink_isConnected)

  /***************** From pni/pnicodeobj.h *****************/
#if 0
  panSymbol_MAPFUNC (pniCodeobj_load,            pniCodeobj_load_enqueue)
#else
  panSymbol_MAPFUNC (pniCodeobj_load,            pniCodeobj_load_immediate)
#endif

  /***************** From libc *****************/
  panSymbol_MAPFUNC (memcpy,  panKNodeUtil_memcpy)
  panSymbol_MAPFUNC (memset,  panKNodeUtil_memset)
  panSymbol_MAPFUNC (memcmp,  panKNodeUtil_memcmp)
  panSymbol_MAPFUNC (htons,   panKNodeUtil_htons)
  panSymbol_MAPFUNC (ntohs,   panKNodeUtil_ntohs)
  panSymbol_MAPFUNC (htonl,   panKNodeUtil_htonl)
  panSymbol_MAPFUNC (ntohl,   panKNodeUtil_ntohl)

  { NULL, NULL }
};
