/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/linux2/knode_util.h,v 1.1 1997/12/10 06:58:35 nygren Exp $
 *
 * FILE:    knode_util.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Utility functions (wrappers, in many cases) to functions
 * either not available in or not exported by the kernel.
 *
 */

#ifndef KNODE_UTIL_H_INC
#define KNODE_UTIL_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/nodeaddr.h>
#include <common/swsstream.h>

extern void *
panKNodeUtil_memcpy(void *dest, const void *src, size_t n);

extern int
panKNodeUtil_memcmp(const void *s1, const void *s2, size_t n);

extern void *
panKNodeUtil_memset(void *s, int c, size_t n);

extern unsigned long int
panKNodeUtil_htonl(unsigned long int hostlong);

extern unsigned short int
panKNodeUtil_htons(unsigned short int hostshort);

extern unsigned long int
panKNodeUtil_ntohl(unsigned long int netlong);

extern unsigned short int
panKNodeUtil_ntohs(unsigned short int netshort);


#endif /* KNODE_UTIL_H_INC */



