/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/linux2/net_if.h,v 1.2 1998/01/20 23:45:58 nygren Exp $
 *
 * FILE:    net_if.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Provides a network interface to a pan KNode.  Contains routines
 * for creating network sockets and sending/receiving capsules.
 *
 */

#ifndef NODE_NETIF_H_INC
#define NODE_NETIF_H_INC

#include <common/pan-copyright.h>
#include <common/pancodeobj.h>
#include <common/sysconfig.h>
#include <node/nodecodeobj.h>
#include <common/nodeaddr.h>

#include <linux/netdevice.h>

extern panNodeAddr *panNodeAddr_LocalAddr;

extern int
panNodeNetIF_init(void);

extern void
panNodeNetIF_cleanup(void);

extern int
panNodeNetIF_sendCapsule(panNodeAddr *destaddr, panStream *capstart, 
			  int length);

extern void
panNodeAddr_getLocalAddr(panNodeAddr *na);

extern int 
panNodeAddr_setLocalAddr(void); 


#endif /* NODE_NETIF_H_INC */
