/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/linux2/skbuffswseg.h,v 1.1 1997/12/13 05:14:15 nygren Exp $
 *
 * FILE:    skbuffswseg.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Software segments for containing Linux kernel skbuffs.  
 * The software segment contains only a fixed portion of 
 * the skbuff (because the starting address and length of a swseg should
 * never change after creation).  By default, this is the
 * "active region" (ie, not including headroom or tailroom.
 * However, functions may exist in the future for creating additional
 * swsegs that contain portions of the headroom and tailroom.
 *
 * Note that there may also be cases where PAN may hand a swseg off to
 * the system to send it somewhere.  In these cases, there needs to be
 * some convention that PAN will never again modify the swseg.  If
 * not, the swseg needs to get copied first.
 *
 */

#ifndef SKBUFFSWSEG_H_INC
#define SKBUFFSWSEG_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>

#include <linux/skbuff.h>


typedef struct _panSwsegSkbuff {
  panSwseg           sws;	/* The main body of the swseg */
  struct sk_buff    *skb;	/* Pointer to the skbuff */
  int                creditto;	/* set to FREE_READ or FREE_WRITE
				 * depending on who to credit frees to */
} panSwsegSkbuff;


extern panSwseg *
panSwsegSkbuff_create_fromSkbuff(struct sk_buff *skb);

extern panSwseg *
panSwsegSkbuff_create(unsigned size, unsigned headroom, unsigned tailroom);


#endif /* SKBUFFSWSEG_H_INC */



