/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/unixuser/globalsyms_platdep.c,v 1.6 1998/01/20 23:46:26 nygren Exp $
 *
 * FILE:    globalsyms_platdep.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * List of all globally exported symbols with which to initialize the 
 * symbol table.
 *
 * These are symbols that depend on platform-dependent sections of code.
 * (Such as things that may be implemented differently for different
 * types of network interfaces.)
 *
 */

#include <stdio.h>

#include <common/pan-copyright.h>
#include <node/nodecodeobj.h>
#include <node/symtab.h>
#include <node/nodecodeobj.h>
#include <string.h>

#include <pni/pninetwork.h>
#include <pni/pnimisc.h>
#include "app_if.h"

int printf_noop(char *fmt, ...) { return 0; }

panSymbol panSymTab_GlobalSymbols_PlatformDependent[] = {

  /******* From pni/pnimisc.h *******/
#if PAN_DEBUG == 0
  panSymbol_MAPFUNC (pniLog_debug, printf_noop)
#else
  panSymbol_MAPFUNC (pniLog_debug, printf)
#endif
  panSymbol_MAPFUNC (pniLog_msg,   printf)
  panSymbol_MAPFUNC (pniLog_warn,  printf)
  panSymbol_MAPFUNC (pniLog_error, printf)

  /***************** From pni/network.h *****************/
  panSymbol_MAKEFUNC(pniNetwork_sendCapsule)
  
  /***************** From pni/applink.h *****************/
  panSymbol_MAPFUNC (pniAppLink_deliverData,     panNodeAppLink_deliverData)
  panSymbol_MAPFUNC (pniAppLink_isConnected,     panNodeAppLink_isConnected)

  /***************** From pni/pnicodeobj.h *****************/
  panSymbol_MAPFUNC (pniCodeobj_load,            pniCodeobj_load_immediate)

  /***************** From libc *****************/
  panSymbol_MAKEFUNC(memcpy)
  panSymbol_MAKEFUNC(memset)
  panSymbol_MAKEFUNC(memcmp)
  panSymbol_MAKEFUNC(htons)
  panSymbol_MAKEFUNC(ntohs)
  panSymbol_MAKEFUNC(ntohl)
  panSymbol_MAKEFUNC(htonl)

  { NULL, NULL }
};
