/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/unixuser/pni/pninetwork.c,v 1.1 1997/07/15 22:00:54 nygren Exp $
 *
 * FILE:    pninetwork.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Implements networking routines that may be called from executing
 * capsules through the PAN Node Interface.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <node/nodecodeobj.h>
#include <node/codecache.h>
#include <node/environment.h>
#include <node/node.h>

#include <pni/pninetwork.h>

#include "../routing.h"
#include "../net_if.h"

/* Sends a capsule of length, which starts at capstart to the address
 * specified at destaddr.   Returns number of bytes sent on success,
 * otherwise, returns -1 on failure.  */
int
pniNetwork_sendCapsule(pniNodeAddr *destaddr, pniStream *capstart, int length)
{
  return panUNodeNetIF_sendCapsule(panNode_NetIF, destaddr, capstart, length);
}
