/* $Header: /home/dl2/nygren/cvs/pan/src/node/arch/unixuser/sendtest.c,v 1.5 1997/12/10 06:58:38 nygren Exp $
 *
 * FILE:    sendtest.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Hack for sending out a capsule as a quick test...
 *
 */


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <node/nodecodeobj.h>
#include <node/codecache.h>
#include <common/nodeaddr.h>
#include <node/environment.h>

#include "routing.h"
#include "net_if.h"

panCodeobj *panCodeobj_TestCO;

/* Sends out a test capsule to a hardwired node.
 */
void
panUNode_sendTestCapsule(void)
{
  panNodeAddr destaddr;
  panSwseg    *capsws;
  panStream    capps;
  int caplength;
  
  if (!panCodeobj_TestCO)
    { panPrint_error("panUNode_sendTestCapsule: no test codeobj\n");
    return; }

  panPrint_debug("panUNode_sendTestCapsule: creating test capsule\n");

  panNodeAddr_init(&destaddr, htonl(0x121a00f5), htons(9764));  /* mindwipe:9764 */

  capsws = panSwseg_create_byMalloc(panCodeobjName_SIZE
				    + panNodeAddr_SIZE + 256);

  panStream_init(&capps, capsws, 0);

  panCodeobjName_write(&capps, &panCodeobj_TestCO->name);
  panNodeAddr_write(&capps, panNodeAddr_LocalAddr);
  panNodeAddr_write(&capps, &destaddr);
  panStream_write_net_uint32(&capps, 0x12345678);

  panStream_init(&capps, capsws, 0);

  caplength = panCodeobjName_SIZE + 2*panNodeAddr_SIZE + 4;
  
  panPrint_debug("panUNode_sendTestCapsule: sending test capsule"
		 " of length %d\n", caplength);

  panUNodeNetIF_sendCapsule(panNode_NetIF, &destaddr, &capps, caplength);

  panPrint_debug("panUNode_sendTestCapsule: test capsule has been sent\n");

}
