/* $XFree86: xc/programs/Xserver/hw/xfree86/loader/loader.h,v 1.6 1997/03/03 15:55:26 hohndel Exp $ */




/*
 *
 * Copyright 1995,96 by Metro Link, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Metro Link, Inc. not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Metro Link, Inc. makes no
 * representations about the suitability of this software for any purpose.
 *  It is provided "as is" without express or implied warranty.
 *
 * METRO LINK, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL METRO LINK, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
#if defined(Lynx) && defined(sun)
#define const /**/
#endif

#if (defined(__i386__) || defined(__ix86)) && !defined(i386)
#define i386
#endif

#include <node/nodecodeobj.h>
#include <node/codecache.h>
#include <node/symtab.h>

#define LD_UNKNOWN	-1
#define LD_ARCHIVE	0
#define LD_ELFOBJECT	1
#define LD_COFFOBJECT	2
#define LD_XCOFFOBJECT	3
#define LD_AOUTOBJECT   4
#define LD_DLOPEN	5

#define LD_PROCESSED_ARCHIVE -1

/*
 * COFF Section nmumbers
 */
#define N_TEXT       1
#define N_DATA       2
#define N_BSS        3
#define N_COMMENT    4

/*
 * _loader_funcs hold the entry points for a module format.
 */

typedef struct _panBinLoaderFuncs {
  void *(*LoadModule)(int modtype, char *modname, panCodeobj *codeobj);
  void (*ResolveSymbols)(panCodeobj *codeobj);
  int (*CheckForUnresolved)(panCodeobj *codeobj); /* Returns 1 if unresolved
						   * symbols exist. */
  void (*LoaderUnload)(void *);
} panBinLoaderFuncs;


/* Each module loaded has a loaderRec */
typedef struct _panBinLoader {
  panCodeobj *codeobj;		/* The code obj corresponding to this module */
  void	*private;		/* format specific data */
  panBinLoaderFuncs *funcs;	/* funcs for operating on this module */
} panBinLoaderRec;


/* Internal Functions */

extern void *
panBinLoader_getMemRegion(panCodeobj *codeobj, unsigned long offset,
			  int size, char *label);

extern void
panBinLoader_releaseMemRegion(void *addr, int size);

extern int
panBinLoader_copyRegionToBuf(panCodeobj *codeobj, unsigned int offset,
				 void *buf, int size);

extern int
panBinLoader_handleUnresolved(panCodeobj *codeobj, char *symbol);

extern void
panBinLoader_unload(panCodeobj *codeobj);

extern int 
panBinLoader_load(panCodeobj *codeobj);

extern int
panBinLoader_defaultFunc(void);

/*
 * Entry points for the different loader types
 */

#if 0  /*********************************************/

/* LD_COFFOBJECT */
void *COFF2LoadModule(
		      int,
		      char *,
		      int,
		      int
		      );
void COFF2ResolveSymbols(
			 void
			 );
int COFF2CheckForUnresolved(
			    int
			    );
void COFF2UnloadModule(
		       void *
		       );

/* LD_ARCHIVE */
void *ARCHIVELoadModule(
#if NeedFunctionPrototypes
			int,
			char *,
			int,
			int
#endif
			);

/* LD_ELFOBJECT */
void *ELFLoadModule(
#if NeedFunctionPrototypes
		    int,
		    char *,
		    int,
		    int
#endif
		    );
void ELFResolveSymbols(
#if NeedFunctionPrototypes
		       void
#endif
		       );
int ELFCheckForUnresolved(
#if NeedFunctionPrototypes
			  int
#endif
			  );
void ELFUnloadModule(
#if NeedFunctionPrototypes
		     void *
#endif
		     );


#endif  /*********************************************/


/* LD_AOUTOBJECT */
extern void *AOUTLoadModule(int modtype, char *modname, panCodeobj *codeobj);
extern void AOUTResolveSymbols(panCodeobj *codeobj);
extern int  AOUTCheckForUnresolved(panCodeobj *codeobj);
extern void AOUTUnloadModule(void *modptr);

/* LD_ELFOBJECT */
extern void *ELFLoadModule(int modtype, char *modname, panCodeobj *codeobj);
extern void ELFResolveSymbols(panCodeobj *codeobj);
extern int  ELFCheckForUnresolved(panCodeobj *codeobj);
extern void ELFUnloadModule(void *modptr);




