/* $Header: /home/dl2/nygren/cvs/pan/src/node/node.c,v 1.5 1997/12/18 02:33:25 nygren Exp $
 *
 * FILE:    node.c
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Platform-independent code for setting up and maintaining node state.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <node/nodecodeobj.h>
#include <node/codecache.h>
#include <node/environment.h>
#include <node/node.h>
#include <common/nodeaddr.h>


panCapsuleEnv *panNode_CurrentCapsule = NULL;

panCapsuleEnvList *panNode_PendingCapsules = NULL;

panCodeCache *panNode_CodeCache = NULL;

panCodeobj *panCodeobj_DynamicLoadCodeobj = NULL;

/* Initializes platform-independent node resources
 * (such as the list of pending capsules).  
 * Must be called before any capsules are processed.
 * Returns 0 on failure, 1 on success.
 */
int
panNode_init(void)
{
  panNode_CurrentCapsule  = NULL;

  if (!(panNode_PendingCapsules = panCapsuleEnvList_create()))
    { panPrint_error("panNode_init: couldn't create capsule env list\n");
    return 0; }

  if (!(panNode_CodeCache = panCodeCache_create()))
    { panPrint_error("panNode_init: couldn't create code cache\n");
    return 0; }

  /* We may also want to initialize panSymTab_GlobalSymTab here as well,
   * but right now that's dealt with in symtab.c */

  return 1;
}



