/* $Header: /home/dl2/nygren/cvs/pan/src/node/node.h,v 1.4 1997/12/18 02:33:25 nygren Exp $
 *
 * FILE:    node.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Platform-independent code for maintaining node state.
 *
 */

#ifndef NODE_NODE_H_INC
#define NODE_NODE_H_INC

#include <common/pan-copyright.h>
#include <common/pancodeobj.h>
#include <common/sysconfig.h>
#include <node/nodecodeobj.h>
#include <common/nodeaddr.h>
#include <node/environment.h>


/* ************************************************************ *
 * ************ Node-wide global variables. ******************* *
 * ************************************************************ *
 *
 * (should these move into a structure at some point?) 
 */

/* The environment of the capsule currently being evaluated.
 * To reduce memory allocations and frees, capsule envs are sometimes
 * reused, so sometimes this may contain a capsule with 
 * a DONE status. */
extern panCapsuleEnv *panNode_CurrentCapsule; 

/* A list of capsule environments waiting to be handled
 * at some point.  These capsules were deferred because
 * they needed code objects which have recently become available.
 */
extern panCapsuleEnvList *panNode_PendingCapsules;

/* The code cache for the node that contains all code objects
 */
extern panCodeCache *panNode_CodeCache;

/* TEMPORARY: The code object to use for demand loading */
extern panCodeobj *panCodeobj_DynamicLoadCodeobj;


/* The global symbol table for the node (for routines exported to
 * capsule code) is panSymTab_GlobalSymTab in symtab.c.  At some
 * point it may make sense to move it here.
 */


extern int
panNode_init(void);


#endif /* NODE_NODE_H_INC */
