/* $Header: /home/dl2/nygren/cvs/pan/src/panotool/misc.h,v 1.1.1.1 1997/05/14 00:38:35 nygren Exp $
 *
 * FILE:    misc.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Misc utility routines used by panotool.
 *
 */

#ifndef INC_PANOTOOL_MISC_H
#define INC_PANOTOOL_MISC_H

#include <common/pan-copyright.h>
#include <common/sysconfig.h>

/* An element in a list of strings */
typedef struct _stringlistel {
  struct _stringlistel *next;  /* The next element in the list */
  char                 *str;   /* The string held here */
} stringlistel;

/* A list of strings that can be dynamically added to. */
typedef struct _stringlist {
  stringlistel *head;  /* The head of the list */
  stringlistel *tail;  /* The tail of the list */
} stringlist;

/* If the predicate is true, prints the error and exits */
#define REQUIRE_NOT_PRED(pred, errmsg) \
     do {if (pred) { panPrint_error("%s:%d: %s\n",__FILE__,__LINE__,errmsg); \
	exit(-1); } } while(0);

extern stringlist   *stringlist_create(void);
extern void          stringlist_destroy(stringlist *sl);
extern void          stringlist_addtotail(stringlist *sl, char *addstr, 
					  int dup);
extern stringlistel *stringlist_gethead(stringlist *sl);

extern int string_extension_compare(const char *s, const char *ext); 

/* Takes a filename and seeks past any path components and
 * returns a pointer to that offset into fn.  */
extern char *string_file_basename(char *fn);

extern unsigned long ADDR_ROUND_UP(unsigned long x);

#endif /* INC_PANOTOOL_MISC_H */
