/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pniapplink.h,v 1.2 1997/09/09 19:31:30 nygren Exp $
 *
 * FILE:    pni/pniapplink.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Header file for application interface routines
 * as they are exported to capsule routines by the node.
 *
 */

#ifndef PAN_PNI_APPLINK_H_INC
#define PAN_PNI_APPLINK_H_INC

#include <common/pan-copyright.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <node/nodecodeobj.h>
#include <common/nodeaddr.h>

#include <pni/pniswseg.h>
#include <pni/pniswsstream.h>

/* An application linkis really just a 
 * reference-only swseg */
typedef panSwseg pniAppLink;



/* Routines with implementations */

extern pniAppLink *
pniAppLink_getSender(void);

#ifdef PAN_CODEOBJ

/* Routines that are simply mapped to corresponding panSwseg routines */

extern int
pniAppLink_isConnected(pniAppLink *applink);

extern int
pniAppLink_deliverData(pniAppLink *applink, 
		       pniStream *datastart, int length);


#endif /* PAN_CODEOBJ */


#endif /* PAN_PNI_APPLINK_H_INC */
