/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pnicodeobj.h,v 1.3 1997/10/14 21:29:56 nygren Exp $
 *
 * FILE:    pnicodeobj.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Routines related to code objects that are exported through
 * the PAN Node Interface.
 * 
 */

#ifndef PNI_PNICODEOBJ_H_INC
#define PNI_PNICODEOBJ_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swsstream.h>
#include <common/pancodeobj.h>
#include <node/nodecodeobj.h>

#include <pni/pniswsstream.h>
#include <pni/pninetwork.h>

typedef panCodeobjName pniCodeobjName;
typedef panCodeobj     pniCodeobj;

#define pniCodeobjName_SIZE panCodeobjName_SIZE




/* Routines that are simply mapped to corresponding pan routines */

#ifdef PAN_CODEOBJ

extern int 
pniCodeobjName_read(pniCodeobjName *coname, pniStream *ps, int testvalidity);

extern int
pniCodeobjName_write(pniStream *ps, pniCodeobjName *coname);

extern int
pniCodeobj_getLength(const pniStream *startps);


/* Interfaces that may be implemented by code objects.  (These are
 * here to ensure that they're the right type). */

extern void
accept(pniStream *capstart, int caplength);

extern void
init(void);

extern void
finalize(void);

/* A pointer to the code object of the currently executing function
 * (which may be different from the code object of the currently
 * executing function). */
extern pniCodeobj *pniCodeobj_This;

#endif /* PAN_CODEOBJ */


/* Routines with implementations */

extern int
pniCodeobj_load(pniStream *startps, pniNodeAddr *homeaddr);

extern pniSwseg *
pniCodeobj_lookup(pniCodeobjName *coname, int *colength);

extern void
pniSwseg_makePersistent(pniCodeobj *thisco, pniSwseg *sws);

extern void
pniSwseg_releasePersistent(pniCodeobj *thisco, pniSwseg *sws);



#endif /* PNI_PNICODEOBJ_H_INC */
