/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pninetwork.h,v 1.4 1997/12/01 22:16:17 nygren Exp $
 *
 * FILE:    pni/network.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Header file for network interface routines
 * as they are exported to capsule routines by the node.
 *
 */

#ifndef PAN_PNI_NETWORK_H_INC
#define PAN_PNI_NETWORK_H_INC

#include <common/pan-copyright.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <node/nodecodeobj.h>
#include <common/nodeaddr.h>

#include <pni/pniswseg.h>
#include <pni/pniswsstream.h>

typedef panNodeAddr pniNodeAddr;

#define pniNodeAddr_SIZE (panNodeAddr_SIZE)

#define pniCapsuleHeader_SIZE ((pniCodeobjName_SIZE) + (pniNodeAddr_SIZE))

/* Routines with implementations */

extern int
pniNetwork_sendCapsule(pniNodeAddr *destaddr, pniStream *capstart, int length);

#ifdef PAN_CODEOBJ

/* Routines that are simply mapped to corresponding panSwseg routines */

extern unsigned
pniNodeAddr_read(pniNodeAddr *na, pniStream *ps);

extern unsigned
pniNodeAddr_write(pniStream *ps, pniNodeAddr *na);

extern int
pniNodeAddr_compare(pniNodeAddr *na1, pniNodeAddr *na2);

extern void
pniNodeAddr_getLocalAddr(pniNodeAddr *na);

extern int
pniNodeAddr_stringify(char *buf, int buflen, pniNodeAddr *na);


#define pniNodeAddr_dup(dst, src) \
        memcpy((dst), (src), sizeof(pniNodeAddr))

#endif /* PAN_CODEOBJ */


#endif /* PAN_PNI_NETWORK_H_INC */
