/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pniswseg.h,v 1.4 1997/12/01 22:16:18 nygren Exp $
 *
 * FILE:    pni/swseg.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Header file for software segment data structures and routines
 * as they are exported to capsule routines by the node.
 *
 */

#ifndef PAN_PNI_SWSEG_H_INC
#define PAN_PNI_SWSEG_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>

typedef panSwseg pniSwseg;


/* Routines with implementations */

extern pniSwseg *
pniSwseg_create_byMalloc(unsigned length);

extern pniSwseg *
pniSwseg_overlay(pniSwseg *sws, unsigned off, unsigned length);


#ifdef PAN_CODEOBJ

/* Routines that are simply mapped to corresponding panSwseg routines */

extern void 
pniSwseg_chain(pniSwseg *s1, pniSwseg *s2);

extern int 
pniSwseg_getChainLength(pniSwseg *sws);

extern unsigned 
pniSwseg_getBytesInChain(pniSwseg *sws);

extern unsigned 
pniSwseg_getSize(pniSwseg *sws);

extern void
pniSwseg_ref(pniSwseg *sws);

extern void
pniSwseg_unref(pniSwseg *sws);


#endif /* PAN_CODEOBJ */


#endif /* PAN_PNI_SWSEG_H_INC */
