/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pniswsstream.h,v 1.1 1997/07/15 22:01:24 nygren Exp $
 *
 * FILE:    pni/swseg.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Header file for software segment data structures and routines
 * as they are exported to capsule routines by the node.
 *
 */

#ifndef PAN_PNI_SWSSTREAM_H_INC
#define PAN_PNI_SWSSTREAM_H_INC

#include <common/pan-copyright.h>
#include <common/swseg.h>
#include <common/swsstream.h>

#include <pni/pniswseg.h>

typedef panStream pniStream;




/* Routines that are simply mapped to corresponding panStream routines */

#ifdef PAN_CODEOBJ

extern void
pniStream_init(pniStream *ps, pniSwseg *sws, unsigned pos);

extern unsigned
pniStream_seekFwd(pniStream *ps, unsigned offset);

extern unsigned 
pniStream_getBytesRemaining(pniStream *ps);

extern pniSwseg *
pniStream_getState(pniStream *ps, unsigned *curpos);

extern unsigned 
pniStream_copy(pniStream *psdest, pniStream *pssrc, unsigned length);

extern unsigned 
pniStream_read(u_int8_t *dest, pniStream *ps, unsigned length);

extern unsigned 
pniStream_write(pniStream *ps, u_int8_t *src, unsigned length);

#define pniStream_dup(psdst,pssrc) memcpy((psdst),(pssrc),(sizeof(panStream)))

#undef  panStream_WORDIO_MAKEBODY
#undef  panStream_WORDIO_MAKEPROTO
#undef  panStream_WORDIO_MAKEINLINE
#define pniStream_WORDIO_MAKEPROTO
#include <common/swsstream_wordio.h> 

#endif /* PAN_CODEOBJ */

/* The above includes the following routines:

   int pniStream_eofP(panStream *ps);

   [u_]int{8,16,32}_t pniStream_read_[u]int{8,16,32}(panStream *ps);
   void pniStream_write_[u]int{8,16,32}(panStream *ps, [u_]int{8,16,32}_t x);

 */


#endif /* PAN_PNI_SWSSTREAM_H_INC */
