/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pnitimestamp.h,v 1.1 1998/01/18 00:12:03 nygren Exp $
 *
 * FILE:    pni/pnitimestamp.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * 
 *
 */

#ifndef PAN_PNI_TIMESTAMP_H_INC
#define PAN_PNI_TIMESTAMP_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/timestamp.h>

typedef panTimestamp pniTimestamp;

/* Routines with implementations */


#ifdef PAN_CODEOBJ

/* Routines that are simply mapped to corresponding panTimestamp routines */

extern int
pniTimestamp_read(pniTimestamp *ts, pniStream *ps);

extern int
pniTimestamp_write(pniStream *ps, pniTimestamp *ts);

#define pniTimestamp_STRINGIFY_FMT_INSECS   panTimestamp_STRINGIFY_FMT_INSECS
#define pniTimestamp_STRINGIFY_FMT_INUSECS  panTimestamp_STRINGIFY_FMT_INUSECS
#define pniTimestamp_STRINGIFY_FMT_PADUSECS panTimestamp_STRINGIFY_FMT_PADUSECS
#define pniTimestamp_STRINGIFY_FMT_PADSECS  panTimestamp_STRINGIFY_FMT_PADSECS
#define pniTimestamp_STRINGIFY_BUFSIZE      panTimestamp_STRINGIFY_BUFSIZE  
extern char *
pniTimestamp_stringify(char *buf, int buflen, pniTimestamp *ts, int format);

extern int
pniTimestamp_compare(pniTimestamp *ts1, pniTimestamp *ts2);

extern void
pniTimestamp_subtract(pniTimestamp *result, 
		      pniTimestamp *ts1, pniTimestamp *ts2);

extern void
pniTimestamp_normalize(pniTimestamp *ts);

extern int
pniTimestamp_getCurrent(pniTimestamp *ts);

extern int
pniTimestamp_getResolution(pniTimestamp *res);


#endif /* PAN_CODEOBJ */


#endif /* PAN_PNI_TIMESTAMP_H_INC */
