/* $Header: /home/dl2/nygren/cvs/pan/src/pni/pniutil_hashtab.h,v 1.2 1998/01/23 07:43:54 nygren Exp $
 *
 * FILE:    pniutil_hashtab.h
 * AUTHORS: Erik Nygren (nygren@mit.edu)
 *
 * Utility routines provided through the PAN Node Interface for
 * a hash table.  This set of utility routines implements a data structure
 * that, in theory, doesn't *need* to be part of the node interface.
 * It's just provided here for convenience.
 * 
 */

#ifndef PNI_PNIUTIL_HASHTAB_H_INC
#define PNI_PNIUTIL_HASHTAB_H_INC

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swsstream.h>

#include <pni/pniswseg.h>
#include <pni/pniswsstream.h>

typedef pniSwseg pniHashTab;

/* Routines that are simply mapped to corresponding pan routines */

#ifdef PAN_CODEOBJ


#endif /* PAN_CODEOBJ */


/* Routines with implementations */

extern pniHashTab *
pniHashTab_create(int numslots, int keysize,
		  unsigned (*hashfn)(char *));

extern pniSwseg *
pniHashTab_lookup(pniHashTab *ht, char *key);

extern int
pniHashTab_remove(pniHashTab *ht, char *key);

extern int
pniHashTab_insert(pniHashTab *ht, char *key, pniSwseg *value);



#endif /* PNI_PNIUTIL_HASHTAB_H_INC */
