/* $Header: /home/dl2/nygren/cvs/pan/src/test/sha1/sha1baddemo.c,v 1.3 1997/12/10 06:58:46 nygren Exp $
 * 
 * Quick hack for computing the SHA1 checksum of a file.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/sha1.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

/* Prints an SHA1 digest */
void
print_digest(u_int8_t *digestbuf)
{
  int i;

  for (i=0; i<5; i++)
    printf("%02x%02x%02x%02x ", 
	   digestbuf[i*4+0], digestbuf[i*4+1], 
	   digestbuf[i*4+2], digestbuf[i*4+3]);      
}

/* Fills a buffer of size size with random values */
u_int8_t *
make_test_buf(int size)
{
  u_int8_t *newmem;
  int i;

  newmem = malloc(size);
  assert(newmem);
  for (i=0; i<size; i++)
    newmem[i] = i % 0xff;
  return newmem;
}

void
main(int argc, char **argv)
{
  u_int8_t *buf1, *buf2;
  sha1_ctx sha1context;
  u_int8_t digestbuf[SHA1_SIZE];

  /* Make two identical buffers and hash them in
   * different ways.  The hashes will be different
   * in this case, although they should be identical. */

  buf1 = make_test_buf(28812);
  buf2 = make_test_buf(28812);

  sha1_init(&sha1context);
  sha1_update(&sha1context, buf1, 20);    buf1 += 20;
  sha1_update(&sha1context, buf1, 28780); buf1 += 28780;
  sha1_update(&sha1context, buf1, 12);    buf1 += 12;
  sha1_final(digestbuf, &sha1context);
  printf("buf1: ");
  print_digest(digestbuf);
  printf("\n");

  sha1_init(&sha1context);
  sha1_update(&sha1context, buf2, 28812); buf2 += 28812;
  sha1_final(digestbuf, &sha1context);
  printf("buf2: ");
  print_digest(digestbuf);
  printf("\n");
}

