/* $Header: /home/dl2/nygren/cvs/pan/src/test/sha1/sha1sum.c,v 1.3 1997/12/10 06:58:46 nygren Exp $
 * 
 * Quick hack for computing the SHA1 checksum of a file.
 *
 */

#include <common/pan-copyright.h>
#include <common/sysconfig.h>
#include <common/swseg.h>
#include <common/swsstream.h>
#include <common/pancodeobj.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

void sha1_file(char *infilename);

void
main(int argc, char **argv)
{
  int i;

  for (i=1; i<argc; i++)
    sha1_file(argv[i]);
}

void 
sha1_file(char *infilename)
{
  int       infd;		/* Input file descriptor */
  struct stat infstatbuf;	/* Stat info about input file */
  unsigned totalsize;
  panSwseg  *sws;		/* Software segment for input file */
  panStream  ps;		/* panStreams for reading/writing swsegs */
  int i;  
  sha1_ctx sha1context;
  u_int8_t digestbuf[SHA1_SIZE];
  

  panPrint_msg("%s", infilename);
  
  /* Get the size of the input file */
  if (0 != stat(infilename, &infstatbuf))
    { perror("stat");
    panPrint_error("\t*** couldn't stat input file %s\n", 
		   infilename);  return;  }
  totalsize = infstatbuf.st_size;

   panPrint_msg("(%d bytes):", totalsize);

  if (ADDR_NOT_ALIGNED_P(totalsize))
    { panPrint_error("\t*** size of is not 4-byte word aligned.\n"); return; }
  
  /* Now open and create a swseg by mmapping in the file */
  infd = open(infilename, O_RDONLY);
  if (-1 == infd)
    { perror("open"); panPrint_error("\t*** couldn't open file for reading\n"); return; }
  
  sws = panSwseg_create_byMmap(totalsize,
				 PROT_READ, MAP_PRIVATE, infd, 0);
  if (!sws) { panPrint_error("creation of swseg failed!"); return; }
  close(infd);			/* doesn't need to stay open to 
				 * keep the mapping */

    
  panStream_init(&ps, sws, 0); 
  sha1_init(&sha1context);
#if 0
  panStream_sha1_update(&sha1context, &ps, totalsize);
#else
  /*panStream_sha1_update(&sha1context, &ps, 28812);*/

  panStream_sha1_update(&sha1context, &ps, 20);
  panStream_sha1_update(&sha1context, &ps, 28780);
  panStream_sha1_update(&sha1context, &ps, 12);

  /* known to not work
  panStream_sha1_update(&sha1context, &ps, 16);
  panStream_sha1_update(&sha1context, &ps, 28784);
  panStream_sha1_update(&sha1context, &ps, 12);
  */
#endif
  sha1_final(digestbuf, &sha1context);
  if (!panStream_eofP(&ps))
    panPrint_error("not at eof after sha1 hashing\n");
  
  panPrint_msg("\t");
  for (i=0; i<5; i++)
    panPrint_msg("%02x%02x%02x%02x ", 
		 digestbuf[i*4+0], digestbuf[i*4+1], 
		 digestbuf[i*4+2], digestbuf[i*4+3]);      
  panPrint_msg("\n");
  
}
