

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>

#define DATWORDS 12
#define DATLEN   (12*4)

void main(void)
{
  int filedes[2];
  long dataout[DATWORDS];
  long datain[DATWORDS];
  struct timeval rcvtime, senttime;
  int navail;

  malloc(48);

  if (-1 == pipe(filedes)) { perror("pipe"); exit(-1); }
  if (-1 == gettimeofday(&senttime,NULL)) { perror("gettimeofday"); exit(-1); }

  dataout[0] = senttime.tv_sec;
  dataout[1] = senttime.tv_usec;

  if (DATLEN != write(filedes[1], dataout, DATLEN)) {perror("write");exit(-1);}

  malloc(48);

  if (ioctl (filedes[1], FIONREAD, (void *) &navail) == -1)
    { perror ("ioctl"); exit(-1); }

  if (DATLEN != read(filedes[0], datain, DATLEN)) {perror("read");exit(-1);}

  if (-1 == gettimeofday(&rcvtime,NULL))  { perror("gettimeofday"); exit(-1); }

  senttime.tv_sec =  datain[0];
  senttime.tv_usec = datain[1];

  printf("Round-trip time = %d usecs\n", (rcvtime.tv_usec-senttime.tv_usec)
	 + 1000000*(rcvtime.tv_sec-senttime.tv_sec));
 
  
  
}
